#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi
$use_ppc_plugin = 1;   ## <-- DON'T CHANGE THIS SETTING UNLESS YOU OWN THIS PLUGIN


# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin; 

### FULL TEXT SEARCHING SCRIPT


use CGI::Carp qw(fatalsToBrowser); 
use CGI qw(param);
use DBI;
use ppc_ps;
use fmspm;
use scloud;

$default_permissions = 0777;

#$premium_links_first = "false"; ### Depriciated - To set go to the control panel >> settings >> global engine settings >> 4. search settings


use ps_ppc;
#use strict;
#use Benchmark;
#use Time::HiRes;

my ($q, $pages_prev, $pages_next, $db_name, $db_username, $db_password, $mysql_hostname, $mysql_port, 
$script_url, $admin_url, $web_url, $web_dir, $data_dir, $username, $password, $gsettings, $keywords,
$search_templat, $search_links, $addurl, $today_time, $dsn, $dbh, $sec, $min, $hour, $mday, $mon, $year,
$wday, $ydat, $isdst, $mtime, $sql, $sth, $serror, $cat_search, @all_cts, $lvc, $citem, $keydata, 
@akeys, $visible, $size, $catsql, $knr, $searched, $description, $na, $imgk, $nmbr, 
$kitem, $full_texti, $rows,  $modp, $icnt, $pages, $st, $nd, $nr_searchres, 
$main_nd, @row, $realdate, $reviews, $rateit, $rating_image, $time2, $crit, $rgraphic, $perc, $keyname,
$cat_search_orig, $main_st, $ippc, $highnr, $new_win_crit, $title_with_link, $time3,
$cats, $ms, $ecat, @acts, $rdcat, $from_category, $high_number, $fext, $rowcntr, $reald, $nrc, $lv, 
$imgcrit, $all_links, $pg, $cnposition, $hiddenstr, $pgstring, $prev_ppos, $staticpos, $keyitem, $currentpage,
$pvst, $pvnd, $next_ppos, $spls, $st1, $nd1, $nextt, $spcer, $myspacer, $r1, $r2, $prev, $prevnext, $time1,
$orig_keywords, $crnr, $category_sql
);

&get_setup;
fmspm::check_spamb("search2.cgi", "header", "$data_dir");
$q = CGI->new;


#################

$pages_prev = "3";
$pages_next = "3";

$gsettings = &new_gsettings;

$keywords = $q->param('keywords');

$keywords = &get_search_ready($keywords);

print "Content-type: text/html\n\n";


### CHECK SEARCH SPAMMING

if (($gsettings->{searches_per_hour} > 0) and ($q->param('st') eq "") and ($q->param('nd') eq ""))
	{
	&check_search_spamming;
	}





$today_time = time();

### FLOOD CONTROL


$flood_yn = $gsettings->{floodcontrol};
if ($q->param('st') ne ""){$flood_yn = "No";}

if (($flood_yn eq "Yes") or ($flood_yn eq ""))
	{
	$secswait = $gsettings->{flood_seconds};
	

	if ((-e "$data_dir/flcontrol") < 1)
		{
		mkdir ("$data_dir/flcontrol", 0777);
		$stat = chmod($default_permissions,"$data_dir/flcontrol","$data_dir/flcontrol");
		}

	$userip = $ENV{'REMOTE_ADDR'};

	if ($userip =~ /\//) { print "Invalid IP Address"; exit; }
	if ($userip =~ /\\/) { print "Invalid IP Address"; exit; }

	if (-e "$data_dir/flcontrol/$userip")
		{
		($device,$inode,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,
	    $mtime,$ctime,$blksize,$blocks) = stat("$data_dir/flcontrol/$userip");
	    #print "$atime - $mtime - $ctime :: $today_time<BR>";
	    #print $today_time - $mtime . "-- $secswait<BR><BR>";
    
    	$floodhtml = &get_file_contents("$data_dir/flood.html");
    	$floodhtml =~ s/!!web_url!!/$web_url/gi;
    
	   if (($today_time - $mtime) < 2)
	    	{
	    	
	    	$cat_search1 = $q->param('cat_search');
	    	
	    	print qq[
	    	<html>
			<head>
			<title>Searching</title>
			<meta HTTP-EQUIV="REFRESH" CONTENT="$secswait;URL=$script_url/search2.cgi?keywords=$keywords&cat_search=$cat_search1">
			</head>
			<body>
			$floodhtml
			</body>
			</html>
			];
			exit;
	    	}
		open (IPF, "> $data_dir/flcontrol/$userip");
		close (IPF);
		}
		else
		{
		open (IPF, "> $data_dir/flcontrol/$userip");
		close (IPF);
		}
	}


### UPDATE SEARCH CLOUD IF NEEDED

$search_cloud_details = &get_file_contents("$data_dir/scloud1.dat");
($logging) = split (/\t/, $search_cloud_details);
if ($logging eq "Yes") { scloud::do_search_cloud($search_cloud_details, "$script_url/search2.cgi", $data_dir, $web_dir); }


######

$crit = "\"";
$keywords =~ s/$crit//g;

$keywords =~ s/\\//g;
$orig_keywords = $keywords;
$orig_keywords =~ s/ /+/g;

### GET TEMPLATE

$search_templat = &get_file_contents("$data_dir/searchres.html");
$search_links = &get_file_contents("$data_dir/lsearchres_loc.html");
$search_links_prem = &get_file_contents("$data_dir/lsearchres_loc_prem.html");


$keywords9 = $keywords;
$keywords9 =~ s/</&lt;/g; $message =~ s/>/&gt;/g; 

$search_templat =~ s/%%keywords%%/$keywords9/g;
$search_templat =~ s/!!keywords!!/$keywords9/g;

$okeywords = $keywords;
$search_templat =~ s/!!scripts_url!!/$script_url/g;

if ($gsettings->{searchmeth} eq "pseek"){$search_templat =~ s/!!tseeksearch!!/$script_url\/search\.cgi/g;}
	else {$search_templat =~ s/!!tseeksearch!!/$script_url\/search2\.cgi/g;}

$search_templat =~ s/!build_url!/$web_url/g;
$search_templat =~ s/!!build_url!!/$web_url/g;

$addurl = "<a href=\"$script_url/addurl.cgi\">$gsettings->{add_url_link}</a>";
$search_templat =~ s/%%addurl%%/$addurl/g;



### CONNECT TO DB

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$keywords =~ s/'/\\'/g;


### LOG KEYWORDS

if ($gsettings->{log_search_keywords} eq "Yes")
{
	if (($q->param('st') eq "") and ($q->param('nd') eq "") and ($keywords ne ""))
		{

		$search_log_details = &get_file_contents("$data_dir/searchlog.dat");
		($maxlen, $restrict) = split (/\n/, $search_log_details);
		

		if ($restrict eq "Yes")
			{
				for ($ms = 0; $ms < length($q->param('keywords')); $ms++) 
				{
				$oneletter = substr($q->param('keywords'), $ms, 1);
				if (($oneletter !~ /[0-9a-zA-Z]/) and ($oneletter ne " "))
					{
					$log_kw = "No";
					}
				} 
			}
		

		if (length($q->param('keywords')) > $maxlen)
			{
			$log_kw = "No";
			}

		
			if ($log_kw ne "No")
			{
			($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime();
			$year = $year + 1900;
			$mon++;
			$mtime = "$year-$mon-$mday"; 
			#$mtime = "2003-03-01"; 
		
			$sql = "INSERT INTO keywlog SET kwdate = '$mtime', keyword = '$keywords'";
			$sth = $dbh->prepare($sql);
			if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
			$sth->execute;
			#$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
			}
			
		}
}


### PREPARE SQL QUERY

$cat_search = $q->param('cat_search');
$cat_search_orig = $q->param('cat_search');


if (substr($q->param('cat_search'), 0, 4) eq "CST_")
	{
	$category_search = "true";
	
	$cat_search =~ s/CST_//g;
	
	@all_cts = split (/-/, $cat_search);
	
		$lvc = 1;
		$catsql = "AND (";
		foreach $citem (@all_cts)
			{
			$citem = &decode_dir($citem);
			$catsql = $catsql . " (B.l" . $lvc . "= '$citem') AND";
			$lvc++;
			}
		$catsql = substr($catsql, 0, length($catsql) - 3);
		$catsql = $catsql . ")";
	}






### GET EXTRA KEYS/FIELDS 

$keydata = &get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;

$key_upload_data = &get_file_contents("$data_dir/keysupl.dat");
@upl_items = split (/:-o_:/, $key_upload_data); 



### PREPARE SEARCH QUERY

foreach $kitem (@akeys)
	{
	($keyname, $visible, $size, $searched, $description, $na, $imgk, $nmbr) = split (/\t/, $kitem);
	
	if (($searched eq "Yes") and ($imgk ne "Yes") and ($nmbr ne "Y"))
		{
			$full_texti = $full_texti . ",A." . $keyname . "_cust";
		}
	
	}



#### REMOVE DUPLICATES FROM SEARCH RESULTS?

if ($gsettings->{remove_duplicates} eq "Yes") 
	{
	if ($category_search ne "true")
		{
					if ($gsettings->{remove_duplicates_filter} eq "Title")
						{
						$groupby_crit = "title";
						}
						else
						{
						$groupby_crit = "url";
						}
		
		$sql_dup_rem = "GROUP BY $groupby_crit"; 
		}
		else
		{
					if ($gsettings->{remove_duplicates_filter} eq "Title")
							{
							$groupby_crit = "A.title";
							}
							else
							{
							$groupby_crit = "A.url";
							}
		
		$sql_dup_rem = "GROUP BY $groupby_crit"; 
		}
	}



#### GET TOTAL MATCHES

if ($q->param('total') eq "") 
{


if ($category_search ne "true")
	{
	$sql = "SELECT A.*,
	       MATCH (A.title,A.description,A.keywords,A.url,A.email $full_texti) AGAINST ('$keywords') AS SCORE
			 FROM links AS A, dirs AS B 
		       WHERE (MATCH (A.title,A.description,A.keywords,A.url,A.email $full_texti) AGAINST ('$keywords'))
		       AND ((A.newsubm = '') OR (A.newsubm IS NULL))
		       AND (A.cid = B.cid) AND ((B.catlock != 'H') OR (B.catlock IS NULL))
		       $sql_dup_rem
	       ";
	 
	 
	 
	 }
	 else
	 {
	 $sql = "SELECT A.*,
	         MATCH (A.title,A.description,A.keywords,A.url,A.email $full_texti) AGAINST ('$keywords') AS SCORE
	 		   FROM links AS A,
			 		dirs AS B 
		       WHERE (MATCH (A.title,A.description,A.keywords,A.url,A.email $full_texti) AGAINST ('$keywords'))
		       AND (A.cid = B.cid) AND ((B.catlock != 'H') OR (B.catlock IS NULL))
		       $catsql
		       AND ((A.newsubm = '') OR (A.newsubm IS NULL))
		       $sql_dup_rem
	       ";
	    
	    #print "==> $sql <br>";
	    
	 }

#print "==> $sql <br>";



$sth = $dbh->prepare($sql); 
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
$rows = $sth->rows();



}
else
{
$rows = $q->param('total');
}
 


	
#################  PAY-PER-CLICK PLUGIN ##############################

if ($use_ppc_plugin == 1) {$kanoodle_settings = &ppc_settings; $kanoodle_enalbled = $kanoodle_settings->{kanoodle_enalbled}; $searchfeed_enalbled = $kanoodle_settings->{searchfeed_enalbled};}
if (($use_ppc_plugin == 1) and ($kanoodle_enalbled == 11)) { if ($q->param('st') eq ""){$kan_st = 0;} else {$kan_st = $q->param('st');} if ($rows > 0) {$which_search = 1;} else {$which_search = 10;} $all_kan_links = &do_kanoodle($keywords, $kan_st,$which_search); }
if (($use_ppc_plugin == 1) and ($searchfeed_enalbled == 11)) { if ($q->param('st') eq ""){$kan_st = 0;} else {$kan_st = $q->param('st');} if ($rows > 0) {$which_search = 1;} else {$which_search = 10;} $all_searchfeed_links = &do_searchfeed($keywords, $kan_st,$which_search); }

####################################################################

### PREPARE PAGES

$icnt = $rows;
$nr_searchres = $gsettings->{search_nrlinks_perpage};

$modp = ($icnt % $nr_searchres);
$pages = ($icnt - $modp) / $nr_searchres;
if ($modp != 0) {$pages++;}

$st = $q->param('st');
$nd = $q->param('nd');
if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}

$main_nd = $nd;
$main_st = $st;

$ippc = 1;


########### DO MAIN SEARCH QUERY

if ($gsettings->{premium_first_search_results} eq "Y")
	{
   $premorder = "A.premium DESC,";
	}


if ($category_search ne "true") ### IF SEARCHING EVERYTHING
	{

				#  0     1     2      3      4    5    6     7      8    9      10     11     12      13     14     15     16    17
	$sql = "SELECT A.*,
	       MATCH (A.title,A.description,A.keywords,A.url,A.email $full_texti) AGAINST ('$keywords') AS SCORE
			 FROM links AS A, dirs AS B
		       WHERE (MATCH (A.title,A.description,A.keywords,A.url,A.email $full_texti) AGAINST ('$keywords'))
		       AND (A.cid = B.cid) AND ((B.catlock != 'H') OR (B.catlock IS NULL))
		       AND ((A.newsubm = '') OR (A.newsubm IS NULL))
	          $sql_dup_rem ORDER BY $premorder SCORE DESC LIMIT $st, $nr_searchres
	       ";
	 }
	 else ### IF SEARCHING IN SPECIFIC CATEGORIES
	 {

	 $sql = "SELECT A.*,
	         MATCH (A.title,A.description,A.keywords,A.url,A.email $full_texti) AGAINST ('$keywords') AS SCORE
	 		   FROM links AS A,
			 		dirs AS B 
		       WHERE (MATCH (A.title,A.description,A.keywords,A.url,A.email $full_texti) AGAINST ('$keywords'))
		       AND (A.cid = B.cid) AND ((B.catlock != 'H') OR (B.catlock IS NULL))
		       $catsql
		       AND ((A.newsubm = '') OR (A.newsubm IS NULL))
		       $sql_dup_rem ORDER BY $premorder SCORE DESC LIMIT $st, $nr_searchres
	       ";
	
	 }

	 
	 

#$catsql

$sth = $dbh->prepare($sql);



if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}

### NUMBER OF MATCHES

#$rows = $sth->rows();
$search_templat =~ s/%%link_matches%%/$rows/g;
$search_templat =~ s/!!link_matches!!/$rows/g;


### INITIALIZE VARS

my $modifyl = $gsettings->{modify_text};
my $rptdl = $gsettings->{report_dead_link};
my $search_res_newwin = $gsettings->{search_res_newwin};

### GET LINKS

$high_number = $q->param('hn');

$crnr = $st + 1;

$highnr = 0;

$nowtime = time();

while ( my @row = $sth->fetchrow_array)
	{

	### GET HIGHEST RELEVANCE SCORE
	if ($highnr == 0)
		{
		if ($high_number eq "")
			{
			$high_number = $row[27 + $knr];
			}
		}
	$highnr++;
	
	#######

	
#	if (($ippc > $st) and ($ippc <= $nd))
#    {
    
	if (($row[21] == 0) and ($row[13] > 0))
	{ $row[21] = 99999999999999; }
    
    
    if (($row[13] > 0) and ($row[21] > $nowtime))
    	{
    	$search_links_tmp = $search_links_prem;
    	}
    	else
    	{
    	$search_links_tmp = $search_links;
    	}
    
			
	 		### %%title_with_link%%
	 		if ($search_res_newwin eq "Yes")
	 			{
	 			$new_win_crit = " target=\"_blank\"";
	 			}
			
			
			if ($gsettings->{hideurls} eq "No")
				{
				$title_with_link = "<a href=\"$row[5]\" $new_win_crit>$row[2]</a>";
				}
				else
				{
				$title_with_link = "<a href=\"$script_url/go.cgi?id=$row[0]\" $new_win_crit>$row[2]</a>";
				}
			
			
			
			if (($row[5] eq "http://") or ($row[5] eq ""))
				{
				$title_with_link = "$row[2]";
				}
			
			
			$search_links_tmp =~ s/!!nr!!/$crnr/g; $crnr++;
			$search_links_tmp =~ s/%%title_with_link%%/$title_with_link/g;
			$search_links_tmp =~ s/!!title_with_link!!/$title_with_link/g;

			$search_links_tmp =~ s/!!cid!!/$row[1]/g;
			$search_links_tmp =~ s/!!id!!/$row[0]/g;
			
			### !!title_without_link!!
			
			$search_links_tmp =~ s/!!title_without_link!!/$row[2]/g;
			
			### %%description%%
			

			
			
			
			$search_links_tmp =~ s/%%description%%/$row[3]/g;
			$search_links_tmp =~ s/!!description!!/$row[3]/g;
			
			$search_links_tmp =~ s/!!listing_keywords!!/$row[4]/g;
			
			### !!url!! or !!itemurl!!
			$search_links_tmp =~ s/!!url!!/$row[5]/g;
			$search_links_tmp =~ s/!!itemurl!!/$row[5]/g;
			$search_links_tmp =~ s/!!hidden_url!!/$script_url\/go\.cgi?id=$row[0]/g;

			
			
			### !!name!!
			$search_links_tmp =~ s/!!name!!/$row[8]/g;

			### !!email!!
			$search_links_tmp =~ s/!!email!!/$row[9]/g;
			
			### !!gethtml!!
			$search_links_tmp =~ s/!!gethtml!!/$script_url\/gethtml\.cgi?id=$row[0]-$row[1]/g;
			
			### %%date%%
			$reald = $row[17];

			$realdate = $row[17];

			$realdate = &decode_date($row[17]);
			$search_links_tmp =~ s/%%date%%/$realdate/g;
			$search_links_tmp =~ s/!!date!!/$realdate/g;
			
			### %%votes%% 
			if ($row[11] eq "") { $row[11] = 0; }
			$search_links_tmp =~ s/%%votes%%/$row[11]/g;
			$search_links_tmp =~ s/!!votes!!/$row[11]/g;
			
			$nrc = "";
			if ($row[23] > 0) { $nrc = "($row[23])"; }
			
			$reviews = "<a href=\"$script_url/reviews.cgi?id=$row[0]&cid=$row[1]\">$gsettings->{comments}</a> $nrc";
			$search_links_tmp =~ s/%%reviews%%/$reviews/g;

			$search_links_tmp =~ s/!!rno!!/$nrc/gi;
			$search_links_tmp =~ s/!!review_link_url!!/$script_url\/reviews\.cgi?id=$row[0]&cid=$row[1]/gi;
			
			### %%modify%%
			$modifyl = "<a href=\"$script_url/modify.cgi?id=$row[0]&cid=$row[1]\">$modifyl</a>";
			$search_links_tmp =~ s/%%modify%%/$modifyl/gi;
			$search_links_tmp =~ s/!!modify_link!!/$script_url\/modify\.cgi?id=$row[0]&cid=$row[1]/gi;

			### !!add_to_favorites!!
			$search_links_tmp =~ s/!!add_to_favorites!!/$script_url\/favad\.cgi?id=$row[0]/gi;

			### %%report%%
			$rptdl = "<a href=\"$script_url/rprtb.cgi?id=$row[0]&cid=$row[1]\">$rptdl</a>";
			$search_links_tmp =~ s/%%report%%/$rptdl/gi;
			$search_links_tmp =~ s/!!report_dead_link!!/$script_url\/rprtb\.cgi?id=$row[0]&cid=$row[1]/gi;

			### %%rateit%% %%rating%%
			$rateit = "<a href=\"$script_url/rateit.cgi?id=$row[0]&cid=$row[1]\">$gsettings->{rateit}</a>";
			$search_links_tmp =~ s/%%rateit%%/$rateit/g;
			$search_links_tmp =~ s/!!rate_link_url!!/$script_url\/rateit\.cgi?id=$row[0]&cid=$row[1]/g;
			
			if ($row[10] eq "") { $row[10] = 0; }
			$search_links_tmp =~ s/%%rating%%/$row[10]/g;
			$search_links_tmp =~ s/!!rating!!/$row[10]/g;
			
			
			$rating_image = &get_rating_images($row[10]);
			$search_links_tmp =~ s/%%rating_image%%/$rating_image/gi;
			$search_links_tmp =~ s/!!rating_image!!/$rating_image/gi;

			### %%hits%%
			if ($row[12] eq "") { $row[12] = 0; }
			$search_links_tmp =~ s/%%hits%%/$row[12]/g;
			$search_links_tmp =~ s/!!hits!!/$row[12]/g;
			
		### NEW
		if	($reald ne "")
			{
			$time1 = 86400 * $gsettings->{days1};
			if ($reald >= ($today_time - $time1)){ $crit = "<img src=\"!build_url!/new1.gif\">"; $search_links_tmp =~ s/!!new!!/$crit/g; }

			$time2 = 86400 * $gsettings->{days2};
			if ($reald >= ($today_time - $time2)){ $crit = "<img src=\"!build_url!/new2.gif\">"; $search_links_tmp =~ s/!!new!!/$crit/g; }

			$time3 = 86400 * $gsettings->{days3};
			if ($reald >= ($today_time - $time3)){ $crit = "<img src=\"!build_url!/new3.gif\">"; $search_links_tmp =~ s/!!new!!/$crit/g; }
			}
			$search_links_tmp =~ s/!!new!!//gi;


		### POP
			if ($row[12] > $gsettings->{pop_links_amount})
				{
				$crit = "<img src=\"!build_url!/pop.gif\">";
				$search_links_tmp =~ s/!!pop!!/$crit/gi;
				}
				else
				{
				$search_links_tmp =~ s/!!pop!!//gi;
				}



		### GET CATGORY
			
			#$cats = ""; $ecat = ""; $rdcat = ""; $lv = 0;
			#for ($ms = 0; $ms < 16; $ms++) 
			#	{
			#	if ($row[$ms] ne "")
			#		{
			#		$cats = $cats . $row[$ms] . "/";
			#		$ecat = $ecat . &encode_dir($row[$ms]) . "-";
			#		$rdcat = $rdcat . &encode_dir($row[$ms]) . "/";
			#		$lastcat = $row[$ms];
			#		$lv++;
			#		}
			#	}
			#chop($ecat);

			#$cats = substr($cats, 0, (length($cats) - 1));
			#$cats =~ s/\// \/ /gi;
			
			#if ($gsettings->{dyn_stat} eq "Dynamic")
			#	{
			#	$from_category = "<a href=\"$script_url/dirs.cgi?lv=$lv&ct=$ecat\">$cats</a>";
			#	$lastcat = "<a href=\"$script_url/dirs.cgi?lv=$lv&ct=$ecat\">$lastcat</a>";
			#	}
			#	else
			#	{
			#	$from_category = "<a href=\"$web_url/$rdcat\">$cats</a>";
			#	$lastcat = "<a href=\"$web_url/$rdcat\">$lastcat</a>";
			#	}

			$catocrit1 = "%%category1%%-" . $row[1] . "end1g";
			$catocrit2 = "!!category1!!-" . $row[1] . "end2g";
			$catocrit3 = "!!short_category1!!-" . $row[1] . "end3g";

			$search_links_tmp =~ s/%%category%%/$catocrit1/g;
			$search_links_tmp =~ s/!!category!!/$catocrit2/g;
			$search_links_tmp =~ s/!!short_category!!/$catocrit3/g;

		###################


			### GET RELEVANCE %%rgraphic%% %%relevance%%
			if (($row[27 + $knr] != 0) and ($high_number != 0))
				{
				$perc = $row[27 + $knr] / $high_number * 100;
				$perc = sprintf("%5.2f",$perc);
				}
				
			
			if (int($perc) == 100) { $perc = "99.99"; }
			
			$search_links_tmp =~ s/%%relevance%%/$perc%/g;
			$search_links_tmp =~ s/!!relevance!!/$perc%/g;
				
				####
			
			$rgraphic = "";
			
			if ($perc < 100) { $rgraphic = "<img src=\"$web_url/100.gif\">"; }
			if ($perc < 91) { $rgraphic = "<img src=\"$web_url/90.gif\">"; }
			if ($perc < 81) { $rgraphic = "<img src=\"$web_url/80.gif\">"; }
			if ($perc < 71) { $rgraphic = "<img src=\"$web_url/70.gif\">"; }
			if ($perc < 61) { $rgraphic = "<img src=\"$web_url/60.gif\">"; }
			if ($perc < 51) { $rgraphic = "<img src=\"$web_url/50.gif\">"; }
			if ($perc < 41) { $rgraphic = "<img src=\"$web_url/40.gif\">"; }
			if ($perc < 31) { $rgraphic = "<img src=\"$web_url/30.gif\">"; }
			if ($perc < 21) { $rgraphic = "<img src=\"$web_url/20.gif\">"; }
			if ($perc < 11) { $rgraphic = "<img src=\"$web_url/10.gif\">"; }
			
			$search_links_tmp =~ s/%%rgraphic%%/$rgraphic/g;
			$search_links_tmp =~ s/!!rgraphic!!/$rgraphic/g;
		
			### !!more_info_url!!
			if ($gsettings->{dyn_stat} eq "Static")
				{
				
				if ($gsettings->{more_info_naming} eq "linktitles")
					{
					$moreinfo_name = &get_more_info_file_name($row[2], $row[0]);
					$fext = "$web_url/!!static!!-$row[1]ggend" . $moreinfo_name;
					}
					else
					{
					$fext = "$web_url/!!static!!-$row[1]ggend" . $row[0];
					}
				
				
				
				
				$fext = $fext . $gsettings->{gen_file_ext};
		
				$search_links_tmp =~ s/!!more_info_url!!/$fext/g;
				}
				else
				{
				$search_links_tmp =~ s/!!more_info_url!!/$script_url\/linfo\.cgi?id=$row[0]/g;
				}


			#### EXTRA FIELDS KEYS
			
			$rowcntr = 27;
			foreach $keyitem(@akeys)
				{
				($keyname, $visible, $size, $searched, $description, $na, $imgk, $nmbr, $req, $allow_html, $carriage_pagebreak) = split (/\t/, $keyitem);
				
				if ($nmbr eq "Upload")
					{
					 if ($row[$rowcntr] eq "") 
						 {
						$search_links_tmp =~ s/!!$keyname!!/$na/g;
						 }
						else
						 {
							$apreapp = ""; $aapend = "";
							foreach $upload_item (@upl_items)
								{
								($fieldname_t, $filetypes_t, $preappend_t, $append_t, $uploadsize_t) = split (/:o:-:o:/, $upload_item);
								if ($keyname eq $fieldname_t) { $apreapp = $preappend_t; $aapend = $append_t; }
								}
									
							$upcrit = $apreapp . "$web_url/imagefiles/$row[0]/$keyname" . "." . $row[$rowcntr] . $aapend;
							$search_links_tmp =~ s/!!$keyname!!/$upcrit/g;
						 } 
			
					 }
					elsif ($imgk eq "Yes")
						{
						if ($row[$rowcntr] ne ""){$imgcrit = "<img src=\"$row[$rowcntr]\" border=\"0\">";} else { $imgcrit = $na; }
						$search_links_tmp =~ s/%%$keyname%%/$imgcrit/gi;
						$search_links_tmp =~ s/!!$keyname!!/$imgcrit/gi;
						}
						else
						{
						if ($allow_html eq "N") { $row[$rowcntr] =~ s/</&lt;/g; $row[$rowcntr] =~ s/>/&gt;/g; }
						if ($carriage_pagebreak eq "Y") { $row[$rowcntr] =~ s/\n/<BR>/gi; }


						if ($row[$rowcntr] eq "") { $row[$rowcntr] = $na; }
						$search_links_tmp =~ s/%%$keyname%%/$row[$rowcntr]/gi;
						$search_links_tmp =~ s/!!$keyname!!/$row[$rowcntr]/gi;
						}
						$rowcntr++;
				}


			##### INSERT IMAGES
			
			$search_links_tmp = &insert_images($search_links_tmp, "$script_url/go.cgi?id=$row[0]");


			$domaincrit = $row[5];
			$domaincrit =~ s/http:\/\///gi;
			if ($domaincrit =~ /\//){ @domainrtmp = split(/\//, $domaincrit); $domainr = $domainrtmp[0];} else {$domainr = $domaincrit; }
			$search_links_tmp =~ s/!!domain!!/$domainr/gi;


			### INSERT UPLOAD IMAGE IF ANY
			if ($search_links_tmp =~ /!!link_image!!/i)
			{
			$img_fname = "$web_dir/imagefiles/" . $row[0] . "." . $row[6];
	
			$image_width = $gsettings->{image_width};
			$image_height = $gsettings->{image_height};
	
			if ($image_width > 0) { $imgw = qq[ width="$image_width" ]; }
			if ($image_height > 0) { $imgh = qq[ height="$image_height" ]; }
	
						
				if (-e "$img_fname")
					{
					$the_image_url = "$web_url/imagefiles/$row[0]" . "." . $row[6];
					$the_link_image = qq[<img src="$the_image_url" border="0" $imgw $imgh>];
					$search_links_tmp =~ s/!!link_image!!/$the_link_image/gi;
					}
					else
					{
					if ($gsettings->{default_image} =~ /http:/)
						{
						$the_image_url = $gsettings->{default_image};
						$the_link_image = qq[<img src="$the_image_url" border="0" $imgw $imgh>];
						$search_links_tmp =~ s/!!link_image!!/$the_link_image/gi;
						}
						else
						{
						$search_links_tmp =~ s/!!link_image!!//gi;
						}
	
					}
			}
			elsif ($search_links_tmp =~ /!!link_file!!/i)
			{
				$the_image_url = "";
				if ($row[6] ne ""){ $the_image_url = "$web_url/imagefiles/$row[0]" . "." . $row[6]; }
				elsif ($gsettings->{default_image} =~ /http:/) { $the_image_url = 	$gsettings->{default_image};}
				
				$search_links_tmp =~ s/!!link_file!!/$the_image_url/gi;
			}
			

		$imgnm = "";
		if ($row[6] ne ""){$imgnm = $row[0] . "." . $row[6];}
		$search_links_tmp =~ s/!!image_name!!/$imgnm/gi;
			
			
		###########
		
		$all_links = $all_links . $search_links_tmp;
		
		
		### GET CATEGORIES
		

		$objname = "C" . $row[0];
		$catobj{$objname} = $row[1];
		$category_sql = $category_sql . " (cid = $row[1]) OR";
		
		#}
	#$ippc++;
	}


### GET CATEGORIES

if ($rows > 0)
{

$category_sql = substr($category_sql, 0, length($category_sql) - 2);
$sql = "SELECT * FROM dirs WHERE $category_sql";

$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
while ( my @row = $sth->fetchrow_array)
	{
			
			$cats = ""; $ecat = ""; $rdcat = ""; $lv = 0;
			for ($ms = 2; $ms < 18; $ms++)
				{
				if ($row[$ms] ne "")
					{
					$cats = $cats . $row[$ms] . "/";
					$ecat = $ecat . &encode_dir($row[$ms]) . "-";
					$rdcat = $rdcat . &encode_dir($row[$ms]) . "/";
					$lastcat = $row[$ms];
					$lv++;
					}
				}
			chop($ecat);


		if ($gsettings->{dyn_stat} eq "Dynamic")
			{
			$from_category = "<a href=\"$script_url/dirs.cgi?lv=$lv&ct=$ecat\">$cats</a>";
			$lastcat = "<a href=\"$script_url/dirs.cgi?lv=$lv&ct=$ecat\">$lastcat</a>";
			}
			else
			{
			$from_category = "<a href=\"$web_url/$rdcat\">$cats</a>";
			$lastcat = "<a href=\"$web_url/$rdcat\">$lastcat</a>";
			}	
	
	$rpl = "!!category1!!-" . $row[0] . "end2g";
	$rpl2 = "%%category1%%-" . $row[0] . "end1g";
	$all_links =~ s/$rpl/$from_category/g;
	$all_links =~ s/$rpl2/$from_category/g;

	$replccr = "!!short_category1!!-" . $row[0] . "end3g";
	$all_links =~ s/ $replccr/$lastcat/g;
	
	$replccr2 = "!!static!!-" . $row[0] . "ggend";
	$all_links =~ s/$replccr2/$rdcat/g;

	}

}

$sth->finish;
$dbh->disconnect;






#########

if ($rows < 1)
	{
	if ($gsettings->{nomatch_template} eq "default_tmpl")
		{
		$search_templat =~ s/%%searchresults%%/$gsettings->{no_match_text}/g;
		
#################  PAY-PER-CLICK PLUGIN ##############################

		if (($use_ppc_plugin == 1) and ($kanoodle_enalbled == 11)) { $search_templat =~ s/%%kanoodle_search%%/$all_kan_links/g; }
		if (($use_ppc_plugin == 1) and ($searchfeed_enalbled == 11)) { $search_templat =~ s/%%searchfeed_search%%/$all_searchfeed_links/g; }
		
####################################################################

		}
		else
		{
		&use_nomatch_template; exit;
		}
	}
	else
	{
	$search_templat =~ s/%%searchresults%%/$all_links/g;
	
#################  PAY-PER-CLICK PLUGIN ##############################
	
	if (($use_ppc_plugin == 1) and ($kanoodle_enalbled == 11)) { $search_templat =~ s/%%kanoodle_search%%/$all_kan_links/g; }
	if (($use_ppc_plugin == 1) and ($searchfeed_enalbled == 11)) { $search_templat =~ s/%%searchfeed_search%%/$all_searchfeed_links/g; }

####################################################################

	}


#### PAGES 


	for ($ms = 0; $ms < $pages; $ms++) 
		{
		$pg = $ms + 1;
		if ($nd == ($pg * $nr_searchres)){ $cnposition = $pg; }
		}
	if ($cnposition < $pages_next) { $pages_next = $pages_next + $pages_next - ($cnposition - 1); }

	$hiddenstr = "";
	$pgstring = "";
	
	if ($main_nd eq "") {$main_nd = $nr_searchres;}
	
	for ($ms = 0; $ms < $pages; $ms++)
		{
		$pg = $ms + 1;
		
			if ($main_nd == ($pg * $nr_searchres))
				{
				$pgstring = $pgstring . " [$pg] ";
				$currentpage = $pg;
				}
			  	elsif (($pg >= ($cnposition - $pages_prev)) and ($pg <= ($cnposition + $pages_next)))
				{
				$st = ($pg * $nr_searchres) - $nr_searchres;
				$nd = ($pg * $nr_searchres);
				$pgstring = $pgstring . "<a href=\"$script_url/search2.cgi?st=$st&nd=$nd&keywords=$orig_keywords&cat_search=$cat_search_orig&hn=$high_number&total=$rows\">$pg</a> ";
			   }
      } 

			####  PAGES NAVIGATION
			if (($cnposition - $pages_prev) > 1)
				{
				$prev_ppos = $cnposition - $pages_prev;
				$staticpos = $prev_ppos - 1;
				$prev_ppos = $prev_ppos - 2;
				$pvst = $prev_ppos * $nr_searchres;
				$pvnd = ($prev_ppos * $nr_searchres) + $nr_searchres;
				$pgstring = "<a href=\"$script_url/search2.cgi?st=$pvst&nd=$pvnd&keywords=$orig_keywords&cat_search=$cat_search_orig&hn=$high_number&total=$rows\"><<</a> " . $pgstring;
				}

			####  PAGES NAVIGATION
			if (($cnposition + $pages_next) < $pages)
				{
				$next_ppos = $cnposition + $pages_next;
				$staticpos = $next_ppos + 1;
				$pvst = $next_ppos * $nr_searchres;
				$pvnd = ($next_ppos * $nr_searchres) + $nr_searchres;
				$pgstring = $pgstring . "<a href=\"$script_url/search2.cgi?st=$pvst&nd=$pvnd&keywords=$orig_keywords&cat_search=$cat_search_orig&hn=$high_number&total=$rows\">>></a> ";
				}


if ($pgstring eq "0") { $pgstring = ""; }
if ($pgstring eq " [1] ") { $pgstring = ""; }

if ($pgstring ne "") {$pgstring =  $gsettings->{pages} . $pgstring; }

$search_templat =~ s/%%pages%%/$pgstring/gi;

$search_templat =~ s/%%kanoodle_search%%//g;
$search_templat =~ s/%%searchfeed_search%%//g;



### PREV NEXT PAGES

$st = $q->param('st');
$nd = $q->param('nd');
if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}


$spls = $modp;
if ($spls == 0){$spls++;}

if ($nd <= ($icnt - $spls))
{
	$st1 = $st + $nr_searchres;
	$nd1 = $nd + $nr_searchres;
	$nextt = "<a href=\"$script_url/search2.cgi?st=$st1&nd=$nd1&keywords=$orig_keywords&cat_search=$cat_search_orig&total=$rows&hn=$high_number\">$gsettings->{nextpage}</a> ";
}

 if ($st > 0)
	 	{
		$st1 = $st - $nr_searchres;
		$nd1 = $nd - $nr_searchres;
		$prev = "<a href=\"$script_url/search2.cgi?st=$st1&nd=$nd1&keywords=$orig_keywords&cat_search=$cat_search_orig&hn=$high_number&total=$rows\">$gsettings->{prevpage}</a> ";
		}

if (($prev ne "") and ($nextt ne ""))
	{
	$spcer = " | ";
	}
	else
	{
	$spcer = " ";
	}
	  
	$prevnext = $prev . "$spcer" . $nextt;

	if (length($prevnext) > 5){$myspacer = " | ";}

	#if ($rows > 0)
	#{
	#print "$prevnext $myspacer Page $targpage of $pg";
	#}

	$search_templat =~ s/%%prevnext%%/$prevnext/g;

	$search_templat = &ts_insert_template_includes($search_templat);
	
	$search_templat = &fill_vars($search_templat); 


#my $btime0 = new Benchmark;
#my $btime1 = new Benchmark;
#print "Script Benchmark: ".timestr(timediff($btime1,$btime0));


###################################################################
### IF WE ARE GOING TO FETCH PPC RESULTS FROM POWERSEEK PPC PLUGIN
###################################################################

$ppc_ps_loc = $config_cgi;
$ppc_ps_loc =~ s/config\.cgi//gi;
$ppc_ps_loc = $ppc_ps_loc . "ppc_login.cgi";



if (((-e "$ppc_ps_loc") > 0) and ($search_templat =~ /!!ppc_results!!/))
	{
	$ppc_results = ppc_ps::get_ppc_results($okeywords, $currentpage, "");

	$search_templat =~ s/!!ppc_results!!/$ppc_results/gi;
	}
###################################################################

$keywords9 = $keywords;
$keywords9 =~ s/</&lt;/g; $message =~ s/>/&gt;/g; 

$search_templat =~ s/!!keywords!!/$keywords9/g;
$search_templat =~ s/!!advanced!!/$script_url\/searchadv\.cgi/g;

print $search_templat;







################

sub use_nomatch_template
{
my ($nomatch, $addurl);

$nomatch = &get_file_contents("$data_dir/nomatch.html");

$nomatch =~ s/%%keywords%%/$keywords/g;

#################  PAY-PER-CLICK PLUGIN ##############################

if (($use_ppc_plugin == 1) and ($kanoodle_enalbled == 11)) {$nomatch =~ s/%%kanoodle_search%%/$all_kan_links/g; }
if (($use_ppc_plugin == 1) and ($searchfeed_enalbled == 11)) {$nomatch =~ s/%%searchfeed_search%%/$all_searchfeed_links/g; }

###################################################################
### IF WE ARE GOING TO FETCH PPC RESULTS FROM POWERSEEK PPC PLUGIN
###################################################################

$ppc_ps_loc = $config_cgi;
$ppc_ps_loc =~ s/config\.cgi//gi;
$ppc_ps_loc = $ppc_ps_loc . "ppc_login.cgi";

if (((-e "$ppc_ps_loc") > 0) and ($search_templat =~ /!!ppc_results!!/))
	{
	$ppc_results = ppc_ps::get_ppc_results($okeywords, $currentpage, "NOMATCH");
	$nomatch =~ s/!!ppc_results!!/$ppc_results/gi;
	}
###################################################################


$nomatch =~ s/!!scripts_url!!/$script_url/g;

if ($gsettings->{searchmeth} eq "pseek"){$nomatch =~ s/!!tseeksearch!!/$script_url\/search\.cgi/g;}
	else {$nomatch =~ s/!!tseeksearch!!/$script_url\/search2\.cgi/g;}

$nomatch =~ s/!build_url!/$web_url/g;
$nomatch =~ s/!!build_url!!/$web_url/g;

$nomatch = &ts_insert_template_includes($nomatch);
$nomatch = &fill_vars($nomatch); 

$addurl = "<a href=\"$script_url/addurl.cgi\">$gsettings->{add_url_link}</a>";
$nomatch =~ s/%%addurl%%/$addurl/g;


$nomatch =~ s/!!advanced!!/$script_url\/searchadv\.cgi/g;
$nomatch =~ s/!!rgs_login!!/$script_url\/rgs_login\.cgi/g;
$nomatch =~ s/!!register!!/$script_url\/rgs_register\.cgi/g;
$nomatch =~ s/!!favorites_link!!/$script_url\/fav\.cgi/g;

$nomatch =~ s/%%kanoodle_search%%//g;
$nomatch =~ s/%%searchfeed_search%%//g;
print $nomatch;
exit;
}




sub get_file_contents
{

my ($filename) = @_;
my ($filesize, $thefile);

if ((-e "$filename") > 0) 
	{
$filesize = (-s "$filename");
open (TFILECNTS, "$filename") || die "$filename";
	read(TFILECNTS,$thefile,$filesize);
close (TFILECNTS);
	}

return ($thefile);

}





sub decode_dir
{

my ($coded_string) = @_;
my ($ms, $oneletter, $decoded_string, $plusval, $dechar, $fdchar);

$coded_string =~ s/_/ /g;

$plusval = 0;

 for ($ms = 0; $ms < length($coded_string); $ms++) 
	{
	$oneletter = substr($coded_string, $ms, 1);

	if ($plusval != 0)
		{
		$plusval++;
		if ($plusval == 4) {$plusval = 0;}
		}
	elsif ($oneletter eq ",")
		{
		$dechar = substr($coded_string, ($ms+1), 3);
		$dechar = int($dechar);
		$dechar = chr($dechar);
		
		$dechar =~ s/<//g;
		
		$decoded_string = $decoded_string . $dechar;
		$plusval++;
		}
	else 
		{
		$decoded_string = $decoded_string . $oneletter;
		}

	}

return($decoded_string);
}





sub decode_date
{

my ($tvalue) = @_;
my ($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst,@marray, $rdvalue, $ampm);

($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime($tvalue);
$year = "20" . substr($year, 1, 2);
@marray = ("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");

if (length($min) == 1) {$min = "0" . $min;}
if (length($min) == 1) {$min = "0" . $min;}

if ($gsettings->{date_format} == 0)
	{
	$rdvalue = "$marray[$mon] $mday, $year";
	}
	elsif ($gsettings->{date_format} == 1)
	{
	$rdvalue = "$mday $marray[$mon] $year";
	}
	elsif ($gsettings->{date_format} == 2)
	{
	$mon++;
	if (length($mday) == 1) { $mday = "0" . $mday; }
	if (length($mon) == 1) { $mon = "0" . $mon; }
	$rdvalue = "$year-$mon-$mday";
	}
	elsif ($gsettings->{date_format} == 3)
	{
	$mon++;
	if (length($mday) == 1) { $mday = "0" . $mday; }
	if (length($mon) == 1) { $mon = "0" . $mon; }
	$rdvalue = "$mon-$mday-$year";
	}
	elsif ($gsettings->{date_format} == 4)
	{
	$mon++;
	if (length($mday) == 1) { $mday = "0" . $mday; }
	if (length($mon) == 1) { $mon = "0" . $mon; }
	$rdvalue = "$mday-$mon-$year";
	}

#print "==>$dateformat $rdvalue <BR>";

return ($rdvalue);

}





sub get_rating_images
{
my ($rating) = @_;
my ($image_rate, $decm, $images);

	if ($rating > 0)
			{
			($image_rate, $decm) = split (/\./, $rating);
		
			if (length($decm) == 1)
				{
				if ($decm > 4) {$image_rate++;}
				}
			if (length($decm) == 2)
				{
				if ($decm > 49) {$image_rate++;}
				}
		
			$image_rate = "r" . $image_rate . ".gif";
			$image_rate =~ s/ //g;
			$images = "<img src=\"$web_url/$image_rate\">";
			}

return ($images);
}



sub encode_dir
{

my ($fstring) = @_;
my ($ms, $enc_string, $oneletter, $bstr);

$fstring =~ s/ /_/g;

 for ($ms = 0; $ms < length($fstring); $ms++) 
	{
	
	$oneletter = substr($fstring, $ms, 1);
	
	if (($oneletter !~ /[0-9a-zA-Z]/) and ($oneletter ne "_"))
		{
			$bstr = ord($oneletter);
			if (length($bstr) == 1) {$bstr = "00" . $bstr;}
			if (length($bstr) == 2) {$bstr = "0" . $bstr;}
			$bstr = "," . $bstr;
			$enc_string = $enc_string . $bstr;
		}
		else
		{
			$enc_string = $enc_string . $oneletter;
		}
	}

return ($enc_string);

}



sub insert_images
{
my ($ihtml, $iurl) = @_;
my ($crit);

$crit = "<img src=\""; $ihtml =~ s/\[img\]/$crit/gi;
$crit = "\">"; $ihtml =~ s/\[\/img\]/$crit/gi;
$crit = "<a href=\"$iurl\"><img src=\""; $ihtml =~ s/\[imglnk\]/$crit/gi;
$crit = "\" border=\"0\"></a>"; $ihtml =~ s/\[\/imglnk\]/$crit/gi;							

return ($ihtml);
}



sub ts_insert_template_includes
{

my ($tmpl_page) = @_;
my (@files, $ifilen, $incl, $theincl);

opendir(DIR,"$data_dir");
@files = readdir(DIR);
closedir(DIR);

if ($tmpl_page =~ /%%incl_/)
	{
	foreach $ifilen (@files)
		{
		if (substr($ifilen, 0, 5) eq "incl_")
			{
			$incl = $ifilen;
			$incl =~ s/\.html//g;
			$incl = "%%" . $incl . "%%";
				
				if ($tmpl_page =~ /$incl/)
					{
					$theincl = &get_file_contents ("$data_dir/$ifilen");
					$tmpl_page =~ s/$incl/$theincl/g;
					}
				
			}
		}
	}


if ($gsettings->{searchmeth} eq "pseek"){$tmpl_page =~ s/!!tseeksearch!!/$script_url\/search\.cgi/g;}
	else {$tmpl_page =~ s/!!tseeksearch!!/$script_url\/search2\.cgi/g;}

$tmpl_page =~ s/!build_url!/$web_url/g;
$tmpl_page =~ s/!!scripts_url!!/$script_url/g;


return ($tmpl_page);

}




sub fill_vars
{

my ($filledvar) = @_;
my (@conflines, $statsetting);

$filledvar =~ s/!!scripts_url!!/$script_url/g;

if ($gsettings->{searchmeth} eq "pseek"){$filledvar =~ s/!!tseeksearch!!/$script_url\/search\.cgi/g;}
	else {$filledvar =~ s/!!tseeksearch!!/$script_url\/search2\.cgi/g;}

$filledvar =~ s/!build_url!/$web_url/g;
$filledvar =~ s/!!build_url!!/$web_url/g;

open (GSETT, "$data_dir/gsettings.dat");
	@conflines = <GSETT>;
close (GSETT);
$statsetting = $conflines[29];
chop($statsetting);


####
if ($statsetting =~ /dyn_stat=Dynamic/)
	{
	$filledvar =~ s/!!whatsnew!!/$script_url\/dirs\.cgi?newpop=new/g;
	$filledvar =~ s/!!tophits!!/$script_url\/dirs\.cgi?newpop=pop/g;
	}
	else
	{
	$filledvar =~ s/!!whatsnew!!/$web_url\/new\//g;
	$filledvar =~ s/!!tophits!!/$web_url\/pop\//g;
	}

$filledvar =~ s/!!modify_link_url!!/$script_url\/modify\.cgi/g;
$filledvar =~ s/!!add_url_link!!/$script_url\/addurl\.cgi/g;
$filledvar =~ s/!!add_premium_url_link!!/$script_url\/addurl\.cgi?p=1/g;
$filledvar =~ s/!!rgs_login!!/$script_url\/rgs_login\.cgi/g;
$filledvar =~ s/!!register!!/$script_url\/rgs_register\.cgi/g;
$filledvar =~ s/!!favorites_link!!/$script_url\/fav\.cgi/g;

$topvar = &get_file_contents("$data_dir/frontlink.dat");
if ($topvar eq ""){$filledvar =~ s/!!top!!/$script_url\/fp\.cgi/gi;}else{$filledvar =~ s/!!top!!/$topvar/gi;}

return ($filledvar);
}



sub check_search_spamming
{


$nr_searches_per_hour = $gsettings->{searches_per_hour};


### CHECK IF TMP DIR EXISTS
if ((-e "$data_dir/tmpip") < 1) 
	{
	$status = mkdir("$data_dir/tmpip", 0777);
	$stat = chmod($default_permissions,"$data_dir/tmpip","$data_dir/tmpip");
	}

### CLEAN UP tmpip DIR FOR OLDER SEARCHES

$ipaddress = $ENV{'REMOTE_ADDR'};
$ntime = time();

	opendir(DDIR,"$data_dir/tmpip");
	@afiles = readdir(DDIR);
	foreach $filenamea (@afiles)
		{
			if (($filenamea ne ".") and ($filenamea ne ".."))
			{
			($device,$inode,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks) = stat("$data_dir/tmpip/$filenamea");
				if ($mtime < ($ntime - 3600))
					{
					$stat = unlink ("$data_dir/tmpip/$filenamea");
					}
			}
		}
	closedir (DDIR);




### RECORD IP ADDRESS

if ((-e "$data_dir/tmpip/$ipaddress") < 1)
	{
	open (IPADD, "> $data_dir/tmpip/$ipaddress");
		print IPADD "1";
	close (IPADD);
	$stat = chmod($default_permissions,"$data_dir/tmpip/$ipaddress","$data_dir/tmpip/$ipaddress");
	}
	else
	{
	open (IPADD, "$data_dir/tmpip/$ipaddress");
		$ipnr = <IPADD>;
	close (IPADD);
	
	if ($ipnr >= $nr_searches_per_hour)
		{
		print "Maximum number of searches exceeded. Access denied. Please try again later."; exit;
		}
	
	$ipnr++;
	
	open (IPADD, "> $data_dir/tmpip/$ipaddress");
		print IPADD $ipnr;
	close (IPADD);
	}

}





sub get_more_info_file_name
{

my ($title_without_link, $tllid) = @_;

		$title_without_link_tmp = $title_without_link;
		
			$more_info_pg_name = ""; $title_without_link_tmp =~ s/ /_/gi;
			for ($ms = 0; $ms < length($title_without_link_tmp); $ms++) 
				{
				$oneletter1 = substr($title_without_link_tmp, $ms, 1);
					if (($oneletter1 =~ /[0-9a-zA-Z]/) or ($oneletter1 eq "_"))
					{
					$more_info_pg_name = $more_info_pg_name . $oneletter1;
					}
				}
			$more_info_pg_name = lc($more_info_pg_name);
			if (length($more_info_pg_name) > 80) { $more_info_pg_name = substr($more_info_pg_name, 0, 80); }
			$more_info_pg_name = $more_info_pg_name . "_" . $tllid;
	

return ($more_info_pg_name);

}






sub new_gsettings
{
my $this = {};
my ($scnts, @all_obj_items, $obji, $obj_prp, $obj_val);

$scnts = &get_file_contents("$data_dir/gsettings.dat");
@all_obj_items = split (/\n/, $scnts);

foreach $obji (@all_obj_items)
	{
	($obj_prp, $obj_val) = split (/=/, $obji);
	$this->{$obj_prp} = $obj_val;
	}

bless $this;
return $this;
}




sub get_search_ready
{
my ($search_line) = @_;

my $reline;

$reline = $search_line;

#$reline =~ s/\+/c%2B/g;
$reline =~ s/\[//g;
$reline =~ s/\]//g;
$reline =~ s/%//g;
$reline =~ s/<//g;
$reline =~ s/>//g;
$reline =~ s/\///g;
$reline =~ s/\\//g;
$reline =~ s/\|//g;

return ($reline);
}




sub get_setup
{
my ($exists, $line, $r);

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
my ($return_val, $crits);
$crits = "\"";
$setup_line =~ m/$crits/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crits/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}








#### END CONFIGURATION ########################################################

